<?php
// custom fields for hotdesk
$custom_field['user']['name']['text']='name';
$custom_field['user']['allowed_profiles[]']['multiselect']='allowed_profiles';


$cust_fields = array();

$new_field = array( 
    'section'       => 'user',
    'name'          => 'name',
    'displayname'   => __('Name'),
    'type'          => 'text',
    'variablename'  => 'name',
    'helptext'      => _dgettext('hotdesk','Enter the name of the agent'),
    'template'      => false
);
$cust_fields[]=$new_field;

$new_field = array( 
    'section'       => 'user',
    'name'          => 'allowed_profiles[]',
    'displayname'   => _dgettext('hotdesk','Allowed Profiles'),
    'type'          => 'multiselect',
    'variablename'  => 'allowed_profiles',
    'helptext'      => _dgettext('hotdesk','Select the profiles the agent will have enabled'),
    'template'      => true
);
$cust_fields[]=$new_field;


function hotdesk_update_conf() {
    // Run update_conf.php in order to populate buttons and groups if needed
    $base_plugin_path = substr(dirname(__FILE__),0,strrpos(dirname(__FILE__),"/"));
    $confini = parse_ini_file($base_plugin_path."/configonreload/configonreload.ini");
    exec($confini['reload_script']);
}

function hotdesk_set_custom_on_default_template_add() {
    global $db, $conf, $astman, $fp;
    $jscode = '';
    $selected_def_template = fop2_get_deftemplate();
    $query = "SELECT custom FROM fop2templates WHERE id='%s'";
    $res    = $db->consulta($query,array($selected_def_template));
    if($res) {
        if($db->num_rows($res)>0) {
            $mirow = $db->fetch_row($res);
            $jdata = $mirow[0];
            $data = json_decode($jdata);
            $allowprofile = $data->{'fields'}->{'allowed_profiles'};
            $jscode = '$("#allowed_profiles").val(["'.implode('","',$allowprofile).'"]);'."\n";
            $jscode .= '$("#allowed_profiles").trigger("chosen:updated");'."\n";
            $jscode.="console.log('$allowprofile');\n";
        }
    }
    return $jscode;
}

function hotdesk_update_users_on_template_change($templateid,$users) {
    global $db, $conf, $astman, $fp;

    $query = "SELECT custom FROM fop2templates WHERE id='%s'";

    $res    = $db->consulta($query,array($templateid));
    if($res) {
        if($db->num_rows($res)>0) {
            $mirow = $db->fetch_row($res);
            $jdata = $mirow[0];
            $data = json_decode($jdata);
            $allowprofile = $data->{'fields'}->{'allowed_profiles'};
        }

        if(!$res = $astman->connect($conf['MGRHOST'].':'.$conf['MGRPORT'], $conf['MGRUSER'] , $conf['MGRPASS'], 'off')) {
            unset($astman);
        }


        if ($astman) {
            foreach($users as $exten) {
                $sallow = implode(",",$allowprofile);
                $astman->database_put("HOTDESK/".$exten,"allowed",$sallow);
            }
        }
        hotdesk_update_conf();
    }
}

function hotdesk_populate_data($data) {
    global $allowed_profiles, $selected_allowed_profiles, $db, $astman, $conf, $name;
    $configFile = __DIR__ . '/hotdesk.ini';

    if(count($data)==0) {
        $jscode = hotdesk_set_custom_on_default_template_add();
    } else {
        $jscode = '';
    }

    $allowed_profiles = array();
    $ini_array = parse_ini_file($configFile,true);
    foreach($ini_array as $key => $deta) {
        if(is_array($deta)) {
           $allowed_profiles[]=$key;
        }
    }

    $query = "SELECT id,description FROM devices";
    $res    = $db->consulta($query);
    if($res) {
        if($db->num_rows($res)>0) {
            while($row=$db->fetch_assoc($res)) {
                $name[$row['id']]=$row['description'];
            }
        }
    }

    $selected_allowed_profiles = array();

    if(isset($data['itemid'])) {
        $caller = debug_backtrace();
        if(preg_match("/fop2users/",$caller[0]['file'])) {
            $itemid = $data['itemid'];
            $query  = "SELECT exten FROM fop2users WHERE id='$itemid'";
            $res    = $db->consulta($query);
            if($res) {
                if($db->num_rows($res)>0) {
                    $mirow = $db->fetch_row($res);
                    $exten = $mirow[0];
                    if(!$res = $astman->connect($conf['MGRHOST'].':'.$conf['MGRPORT'], $conf['MGRUSER'] , $conf['MGRPASS'], 'off')) {
                        unset($astman);
                    }
                    if ($astman) {
                        $sl = $astman->database_get("HOTDESK/".$exten,"allowed");
                        if($sl<>"") { 
                            $selected_allowed_profiles = explode(",",$sl);
                        }
                    }
                }
            }
        } else {
            $itemid = $data['itemid'];
            $query = "SELECT custom FROM fop2templates WHERE id='$itemid'";
            $res    = $db->consulta($query,array($itemid));
            if($res) {
                if($db->num_rows($res)>0) {
                    $mirow = $db->fetch_row($res);
                    $jdata = $mirow[0];
                    $data = json_decode($jdata);
                    $selected_allowed_profiles = $data->{'fields'}->{'allowed_profiles'};
                }
            }
        }

    }

    if($jscode<>'') {
        echo "<script> \$(document).ready(function() {  $jscode });</script>";
    }
}

function hotdesk_edit_user($data) {
    global $db, $astman, $conf, $selected_allowed_profiles, $allowed_profiles;

    $itemid = $data['itemid'];
    $query  = "SELECT exten FROM fop2users WHERE id='$itemid'";
    $res    = $db->consulta($query);
    $allowprofile = $data['allowed_profiles'];

    $selected_allowed_profiles=array();
    foreach($allowprofile as $kk) {
        $selected_allowed_profiles[]=$kk;
    }

    if($res) {
        if($db->num_rows($res)>0) {

            $mirow = $db->fetch_row($res);
            $exten = $mirow[0];

            $values=array();
            $values[] = $data['name'];
            $values[] = $exten;

            $query = "SELECT dial FROM devices WHERE id='%s' AND dial LIKE 'CUSTOM%%'";
            $res = $db->consulta($query,$exten);
            if($db->num_rows($res)>0) {
                // only update if dial is of type custom

                $query = "UPDATE devices SET description='%s' WHERE id='%s'";
                $db->consulta($query,$values);

                $query = "UPDATE users SET name='%s' WHERE extension='%s'";
                $db->consulta($query,$values);

                if(!$res = $astman->connect($conf['MGRHOST'].':'.$conf['MGRPORT'], $conf['MGRUSER'] , $conf['MGRPASS'], 'off')) {
                    unset($astman);
                }

                if ($astman) {
                    $astman->database_put("AMPUSER/".$exten,"cidname",$data['name']);
                    $astman->database_put("AMPUSER/".$exten,"cidnum",$exten);
                    $astman->database_put("HOTDESK/".$exten,"allowed",implode(",",$allowprofile));
                }
                hotdesk_update_conf();
                hotdesk_populate_data($data);
            }
            return true;
        }
    }
}

function hotdesk_edit_template($data) {
    global $db, $astman, $conf, $selected_allowed_profiles, $allowed_profiles, $panelcontext;

    $finaldata = array();
    $templateid = $data['itemid'];
    $query = "SELECT custom FROM fop2templates WHERE id='%s'";
    $res=$db->consulta($query,array($templateid));
    if($res) {
        if($db->num_rows($res)>0) {
            $mirow = $db->fetch_row($res);
            $custom = $mirow[0];
            $finaldata = json_decode($custom,1);
        }
    }

    $allowprofile = $data['allowed_profiles'];
    $finaldata['fields']['allowed_profiles']=$allowprofile;
    $datastore = json_encode($finaldata);

    $values=array();
    $values[] = $datastore;
    $values[] = $templateid;

    $query = "UPDATE fop2templates SET custom='%s' WHERE id='%s'";
    $db->consulta($query,$values);

    if($panelcontext<>'' && $panelcontext<>'GENERAL') {
        $where = " context_id = '$panelcontext' ";
    } else {
        $where = " context_id is null or context_id='GENERAL' ";
    }

    $where .= " AND id_template='$templateid' ";

    $results = $db->select("exten","fop2UserTemplate","",$where);
    $user_extension_to_change = array();
    if(is_array($results)){
        foreach($results as $result){
            $user_extension_to_change[]=$result['exten'];
        }
    }

    hotdesk_update_users_on_template_change($templateid,$user_extension_to_change);

    hotdesk_populate_data($data);

}

function hotdesk_add_template($data) {
    global $db,$astman,$conf,$allowed_profiles,$selected_allowed_profiles;
    $allowprofile = $data['allowed_profiles'];
    $data['itemid']=$data['id']; 

    hotdesk_edit_template($data);

    return true;
}


function hotdesk_add_user($data) {
    global $db,$astman,$conf,$allowed_profiles,$selected_allowed_profiles;

    $allowprofile = isset($data['allowed_profiles'])?$data['allowed_profiles']:array();

    if($data['name']<>'') {
        // Only insert if name is NOT empty when adding
        $values=array();
        $query = "INSERT INTO devices (id,tech,dial,devicetype,user,description) VALUES('%s','%s','%s','%s','%s','%s')";
        $values[] = $data['userid'];
        $values[] = 'custom';
        $values[] = 'CUSTOM/'.$data['userid'];
        $values[] = 'fixed';
        $values[] = $data['userid'];
        $values[] = $data['name'];
        $db->consulta($query,$values);

        $values=array();
        $query = "INSERT INTO users (extension,password,name,voicemail,ringtimer,noanswer,recording,outboundcid,sipname,mohclass) VALUES ('%s','%s','%s','novm',0,'','out=Adhoc|in=Adhoc','','','default')";
        $values[] = $data['userid'];
        $values[] = $data['userid']."xxx";
        $values[] = $data['name'];
        $db->consulta($query,$values);

        if(!$res = $astman->connect($conf['MGRHOST'].':'.$conf['MGRPORT'], $conf['MGRUSER'] , $conf['MGRPASS'], 'off')) {
            unset($astman);
        }

        if ($astman) {
            $astman->database_put("AMPUSER/".$data['userid'],"cidname",$data['name']);
            $astman->database_put("AMPUSER/".$data['userid'],"cidnum",$data['userid']);
            $astman->database_put("AMPUSER/".$data['userid'],"device",$data['userid']);
            $astman->database_put("AMPUSER/".$data['userid'],"language",'');
            $astman->database_put("AMPUSER/".$data['userid'],"noanswer",'');
            $astman->database_put("AMPUSER/".$data['userid'],"outboundcid",'');
            $astman->database_put("AMPUSER/".$data['userid'],"recording",'out=Adhoc|in=Adhoc');
            $astman->database_put("CW",$data['userid'],"DISABLED");
            $astman->database_put("HOTDESK/".$data['userid'],"allowed",implode(",",$allowprofile));
        }
    }
    hotdesk_populate_data($data);
    hotdesk_add_fop2_buttons();
    hotdesk_update_conf();
    return true;
}

function hotdesk_del_fop2_buttons() {
    global $db,$panelcontext;
    $fop_buttons    = fop2_all_buttons();
    $system_buttons = system_all_buttons();
    if(!isset($fop_buttons)) { $fop_buttons = array(); }
    if(!isset($system_buttons)) { $system_buttons = array(); }

    $system_buttons_context = array();
    foreach($system_buttons as $key=>$arradata) {
        if($arradata['context_id']==$panelcontext) {
            $system_buttons_context[$key]=1;
    }
    }

    $del_buttons = array_diff(array_keys($fop_buttons),array_keys($system_buttons_context));

    if(!isset($del_buttons)) { $del_buttons = array(); }
    foreach($del_buttons as $chan) {
        $result = $db->select('id,exten','fop2buttons','',"device='$chan'");
        $id     = $result[0]['id'];
        $exten  = $result[0]['exten'];
        fop2_del_button($id,$exten);
    }

}

function hotdesk_add_fop2_buttons() {
    global $panelcontext;
    $fop_buttons    = fop2_all_buttons();
    $system_buttons = system_all_buttons();
    if(!isset($fop_buttons)) { $fop_buttons = array(); }
    if(!isset($system_buttons)) { $system_buttons = array(); }

    $system_buttons_context = array();
    foreach($system_buttons as $key=>$arradata) {
        if($arradata['context_id']==$panelcontext) {
            $system_buttons_context[$key]=1;
        }
    }

    $add_buttons = array_diff(array_keys($system_buttons_context),array_keys($fop_buttons));

    if(!isset($add_buttons)) { $add_buttons = array(); }
    foreach($add_buttons as $chan=>$dat) {
        $det = $system_buttons[$dat];
        fop2_add_button($det);
    }
}

function hotdesk_del_user($data) {
    global $db, $astman, $conf;

    $id = intval($data['exten']);

    $query = "SELECT dial FROM devices WHERE id='%s' AND dial LIKE 'CUSTOM%%'";
    $res = $db->consulta($query,$id);
    if($db->num_rows($res)>0) {
        // Only remove if type CUSTOM
 
        $query = "DELETE FROM devices WHERE id = '$id'";
        $db->consulta($query);
        $query = "DELETE FROM users WHERE extension = '$id'";
        $db->consulta($query);

        if(!$res = $astman->connect($conf['MGRHOST'].':'.$conf['MGRPORT'], $conf['MGRUSER'] , $conf['MGRPASS'], 'off')) {
            unset($astman);
        }

        if ($astman) {
            $astman->database_del("AMPUSER/".$id,"cidname");
            $astman->database_del("AMPUSER/".$id,"cidnum");
            $astman->database_del("AMPUSER/".$id,"device");
            $astman->database_del("AMPUSER/".$id,"language");
            $astman->database_del("AMPUSER/".$id,"noanswer");
            $astman->database_del("AMPUSER/".$id,"outboundcid");
            $astman->database_del("AMPUSER/".$id,"recording");
            $astman->database_del("CW/",$id);
            $astman->database_del("HOTDESK/".$id,"allowed");
        }

        hotdesk_del_fop2_buttons();
        hotdesk_update_conf();
    }
    return true;
}

function hotdesk_profiles_dashboard_widget($name,$link,$icon) {
    $count = 0;
    $ini_array = parse_ini_file("plugins/hotdesk/hotdesk.ini",true);
    foreach($ini_array as $key => $data) {
        if(is_array($data)) {
            $count++;
        }
    }
    draw_dashboard_widget(_dgettext('hotdesk',$name),$link,$icon,$count);
}
