plugins['hotdesk'] = (function() {

    var hotdesk_alreadylogged = 0;
    var keepaliveTimer = null;
    var hotdesk_autoclose = 0;
    var hotdeskSecretKey = "";

    return { 

        loadLang: function(values) {
            //console.warn('load lang hotdesk');
            var hash = hex_md5(secret+lastkey);
            queuedcommand = "<msg data=\"" + myposition + "|pluginlang|" + language + "~hotdesk" + "|" + hash + "\" />";
            sendcommand();
        },

        setLang: function() {
            // console.warn('set lang hotdesk');
        },

        init: function() {
            // initialization function
            //console.warn("init de hotdesk");
            hotdesk_already_logged =0;
            send("<msg data=\""+myposition+"|hotdeskgetmap|"+myextension+"\" />");
            this.setupUnloadHandler();
            if(typeof pluginconfig['hotdesk']['secret_key'] == 'undefined') {
                hotdeskSecretKey = randomKey = Array.from(crypto.getRandomValues(new Uint8Array(32))).map(b => b.toString(16).padStart(2, '0')).join('');
            } else {
                hotdeskSecretKey = pluginconfig['hotdesk']['secret_key'][''];
            }
            setTimeout(function() { if(hotdesk_alreadylogged == 1) { alertify.log(lang.hotdeskalreadyinposition); }},2000);
        },
        setupUnloadHandler: function() {
            window.addEventListener('beforeunload', (e) => {
                // Send beacon if connected
                if (conectado == 1) {
                    const data = new FormData();
                    data.append('user', myextension);
                    navigator.sendBeacon(window.location.href + '/admin/plugins/hotdesk/force_logout.php', data);
                }
            });
        },

        sendKeepalive: function() {

            console.log("hotdesk send keepalive");
            if (keepaliveTimer) {
                clearTimeout(keepaliveTimer);
            }

            const authToken = 'Bearer ' + btoa(hotdeskSecretKey);
            const params = new URLSearchParams();
            params.append('user', myextension);
            params.append('position', myposition);
            params.append('context', context || ''); // Ensure empty string if undefined
            params.append('channel', atob(hotdeskposition));
            params.append('qchannel', botonitos[myposition].QUEUECHANNEL);

            fetch(window.location.href + '/admin/plugins/hotdesk/keepalive.php', {
                method: 'POST',
                headers: {
                    'Content-Type': 'application/x-www-form-urlencoded',
                    'Authorization': authToken 
                },
                body: params
            })
            .then(response => {
                if (!response.ok) {
                    console.error('Keepalive failed:', response.status);
                }
            })
            .catch(error => {
                console.error('Keepalive error:', error);
            });
            
            // Schedule next execution
            keepaliveTimer = setTimeout(() => this.sendKeepalive(), 6000);
        },

        callback_verified: function(nro,texto,slot) {
            if(nro==myposition) {
                curpin = $('#hotdeskverify').val();
                if(texto==curpin) {
                   $('#hotdesklogin').modal('hide');
                }
            }
        },
        callback_directionhotdesk: function(nro,texto,slot) {
            //console.warn("set direction hotdesk "+texto);
            slot = 1;
            var phoni = $('#phone' + slot + '_' + nro)

            if (phoni == null) {
            } else {
                if (texto == "outbound") {
                    phoni.addClass('saliente');
                } else {
                    phoni.addClass('entrante');
                }
            }
        },
        callback_link: function(nro,texto,slot) {
            if(typeof pluginconfig['hotdesk']['lastdial'] == 'undefined') {
                pluginconfig['hotdesk']['lastdial']={};
                pluginconfig['hotdesk']['lastdial'][''+nro]=texto;
            }
        },
        callback_settexthotdesk: function(nro,texto,slot) {
            //console.warn("set text hotdesk "+texto);
            slot = 1;
            var clidnum = $("#clid" + slot + "_" + nro);

            if (texto.substring(0, 1) == "&") {
                texto = translate(texto);
            }

            if (clidnum == null) {
            } else {
                clidnum.html(texto);
                clidnum.attr('title', texto);
            }
        },
        callback_getvar: function(nro,texto,slot) {
            datadecoded = Base64.decode(texto);
            partes = datadecoded.split("~");
            hotdesk_allowed_profiles = partes[1].split(',');
            if(partes[0].substring(0,7)=='HOTDESK' && hotdesk_alreadylogged==0 && nro==myposition) {
                //console.warn("hotdesk getvar nro "+nro);
                //console.warn("hotdesk getvar data "+datadecoded);
                send("<msg data=\""+myposition+"|hotdeskpositions|0\" />");
            }
        },
        callback_notionline: function(nro,texto,slot) {

            //console.warn("hotdesk callback notionline my position="+myposition+" and texto = "+texto);

            if(myposition==texto && hotdesk_alreadylogged==0) {
               if(typeof(hotdeskposition)=='string') {
                    // prevent positions popup to show on fop2 server reload
                } else {
                    send("<msg data=\""+myposition+"|getallowedprofiles|"+myextension+"\" />");
                }
            }
        },
        callback_disconnectDuplicate: function(nro,texto,slot) {
            window.name="";
            alertify.error(lang.hotdeskdisconnectduplicate);
            foplogout();
        },
        callback_HOTDESKQUEUEREMOVE: function(nro,texto,slot) {
           if(botonitos[nro].LABEL != botonitos[myposition].LABEL) { // only remove if same position/station logs as a different agent
               if(typeof(hotdeskposition)=="string") {
                   if(atob(hotdeskposition)==texto) {
                       //console.warn("hotdesk queue remove, clearing position and allowed profiles");
                       hotdeskposition = undefined;
                       hotdesk_allowed_profiles = [];
                       window.name = removeUrlParameter(window.name,"hotdeskposition");
                       window.name = removeUrlParameter(window.name,"hotdeskprofile");
                   }
               }
           }
        },
        callback_HOTDESKQCHANGET: function(nro,texto,slot) {
            if(nro==myposition) {
                this.sendKeepalive()
                botonitos[myposition].QUEUECHANNEL=Base64.decode(texto);
                if(typeof plugins['presencepause'] == "object") {
                    plugins['presencepause'].enableSelect(); // run enable/disable select from presence pause plugin after setting queuechannel on a fop2 reload
                }
            }
        },
        callback_HOTDESKALREADYLOGGED: function(nro,texto,slot) {
            if(nro==myposition) {
                var getHotdeskPosition  = gup("hotdeskposition");
                if(getHotdeskPosition=="") {
                    //console.warn("hotdesk already logged, set hotdeskposition");
                    hotdesk_alreadylogged=1;
                    hotdeskposition=btoa(texto);
                    window.name = addUrlParameter(window.name,'hotdeskposition',hotdeskposition);
                } else {
                    console.log("skip already logged warning as it was already set before");
                }
            }
        },
        callback_hotdeskpositions: function(nro,texto,slot) {

            var data = jQuery.parseJSON(Base64.decode(texto));

            //console.warn('hotdeskpositions');
            //console.warn(data);

            if(nro==myposition && hotdesk_alreadylogged==0) {

                if(typeof(hotdeskposition)=='string') {
                    console.warn("hotdesk login from another client? discarding...");
                    return;
                }
                
                if(typeof data['start'] == 'undefined') {
                } else {
                    //console.warn("new hotdeskposition start");

                    pin = ("000" + (Math.floor(Math.random() * (9999 - 0 + 1)) + 0)).substr(-4);

                    // Modal para FOP2 bootstrap
                    var newDiv = document.createElement("div");
                    $(newDiv).attr({'id':'hotdesklogin','role':'dialog'}).addClass('modal fade');
                             
                    $(newDiv).html("<div class='modal-dialog' role='document'><div class='modal-content'><div class='modal-header'><h3 class='modal-title' id='titlehotdesk'></h3></div><div class='modal-body'><form class='form-horizontal'><fieldset><div class='form-group'> <label class='col-md-4 control-label' for='position' id='hotdesklabelposition'>Position</label> <div class='col-md-4'><select name='position' id='hotdeskposition'></select> </div></div> <div class='form-group'> <label for='profile' class='col-md-4 control-label' id='hotdesklabelprofile'>Profile</label> <div class='col-md-4'><select name='profile' id='hotdeskprofile' style='width:200px;'></select></div></div> <div class='form-group' id='hotdeskverifygroup'> <label for='verify' class='col-md-4 control-label' id='hotdeskverificationlabel'>Verification</label> <div class='col-md-4'><input type='text' class='form-control' name='verify' id='hotdeskverify' disabled></div></div><div class='form-group'><div class='col-md-12'><button type='button' id='hotdesklogoutbutton' class='btn btn-danger pull-left'>Logout</button><button type='submit' id='hotdeskacceptbutton' class='btn btn-primary pull-right'>Ok</button> </div> </div> </form> <div class='clearfix'></div></div></div></div></div>");
                    $(newDiv).appendTo($('body'));

                    $('#hotdeskverifygroup').hide();

                    $('#hotdesklogoutbutton').off('click').on('click', function() {
                        foplogout();
                    });

                    hacerverificacion=0;

                    if(typeof pluginconfig['hotdesk']['verification_callback'] !== 'undefined') {
                        if(typeof pluginconfig['hotdesk']['verification_callback'][''] !== 'undefined') {
                            hacerverificacion = pluginconfig['hotdesk']['verification_callback'][''];
                            if(hacerverificacion==1) { $('#hotdeskverifygroup').show(); }
                        }
                    }
                    if(hacerverificacion==1) {
                        $('#hotdeskacceptbutton').off('click').on('click', function(event) {
                            event.preventDefault();
                            var setpin = $('#hotdeskverify').val();
                            var chan   = $('#hotdeskposition').val();

                            if(chan!='') {
                                hotdeskpositionvirtual  = botonitos[myposition]['EXTENSION'];
                                hotdeskposition = Base64.encode(chan);
                                //console.warn("hotdesk set hotdeskposition to "+chan);
                                send("<msg data=\"GENERAL|hotdeskdoverify|" + setpin + "~"+hotdeskposition+"~"+hotdeskpositionvirtual+"|\" />");
                                $("#hotdeskacceptbutton").attr("disabled", "disabled");
                                setTimeout(function() { $("#hotdeskacceptbutton").removeAttr("disabled"); }, 30000);
                            }
                        });
                        $('#hotdeskacceptbutton').html(lang.hotdeskverify);
                        $('#hotdesklogoutbutton').html(lang.logout);
                        $('#hotdeskverificationlabel').html(lang.hotdeskverification);
                    } else {
                        $('#hotdeskacceptbutton').html(lang.accept);
                        $('#hotdeskacceptbutton').off('click').on('click', function(event) {
                            event.preventDefault();
                            $('#hotdesklogin').modal('hide');
                        });
                    }

                    $('#hotdeskposition').empty();
                    $('#hotdeskposition').append($('<option>').text('').attr('value', ''));
                    $('#hotdeskprofile').empty();
                    $('#hotdeskprofile').append($('<option>').text('').attr('value', ''));
                    
                    $('#hotdesklogin').on('show.bs.modal', function (e) {
                        $('#hotdeskposition').selectpicker();
                        $('#hotdeskprofile').selectpicker();
                        $('#titlehotdesk').html(lang.enter_sec_code);
                        $('#hotdesklabelposition').html(lang.hotdeskposition);
                        $('#hotdesklabelprofile').html(lang.hotdeskprofile);
                        $('#hotdeskverify').val(pin);

                        $('#hotdeskacceptbutton').prop('disabled',true);

                        // If there is no profile selected, disable button
                        $('#hotdeskposition').on('change',function() {
                            $('#hotdeskacceptbutton').prop('disabled',false);
                            if($("#hotdeskprofile").prop("selectedIndex")==0) {
                                $('#hotdeskacceptbutton').prop('disabled',true);
                            }
                        });

                        // If there is no position selected, disable button
                        $( '#hotdeskprofile' ).on('change',function() {
                            $('#hotdeskacceptbutton').prop('disabled',false);
                            if($("#hotdeskposition").prop("selectedIndex")==0) {
                                $('#hotdeskacceptbutton').prop('disabled',true);
                            }
                        });
                    });

                    $('#hotdesklogin').on('hidden.bs.modal', function (e) {

                        var chan = $('#hotdeskposition').val();
                        var name = botonitos[myposition]['LABEL'];
                        hotdeskposition = Base64.encode(chan);
                        //console.warn("hotdesk close set hotdeskposition to "+chan);
                        plugins['hotdesk'].sendKeepalive();

                        hotdeskpositionextension = chan.split('/').pop(); 
                        hotdeskpositionvirtual   = botonitos[myposition]['EXTENSION'];

                        if($("#hotdeskprofile").prop("selectedIndex")==0 && $("#hotdeskposition").prop("selectedIndex")==0) {
                             console.warn('hotdesk no selection? do nothing');
                        } else {

                            window.name = addUrlParameter(window.name,'hotdeskposition',$('#hotdeskposition option:selected').text());
                            window.name = addUrlParameter(window.name,'hotdeskprofile',$('#hotdeskprofile option:selected').text());

                            var getHotdeskPosition  = gup("hotdeskposition");
                            if(getHotdeskPosition=='') {
                                window.name = addUrlParameter(window.name,'hotdeskposition',getHotdeskPosition);
                            }
                            var getHotdeskProfile  = gup("hotdeskprofile");
                            if(getHotdeskProfile=='') {
                                window.name = addUrlParameter(window.name,'hotdeskprofile',getHotdeskProfile);
                            }

                            hotdeskprofile  = $('#hotdeskprofile').val();
                            //console.warn("hotdesk close set hotdeskprofile to "+hotdeskprofile);
                            var profilename = $("#hotdeskprofile option:selected").html()
                            send("<msg data=\"GENERAL|hotdeskprofile|" + profilename + "~"+hotdeskposition+"|\" />");
                            partes = hotdeskprofile.split("|");
                            var qar = [];
                            for (var i=0,  tot=partes.length; i < tot; i++) {
                                pertes = partes[i].split(",");
                                var cola = pertes[0];
                                var penalty = pertes[1];
                                if(typeof penalty == 'undefined') { penalty = 0; }
                                var qstr = chan+"|Penalty="+penalty+"|MemberName="+name+"|Queue="+cola+"|Profile="+profilename;
                                qar.push(qstr); 
                            }
                            if(typeof pluginconfig['hotdesk']['agent_queue_prefix'] !== 'undefined') {
                                if(typeof pluginconfig['hotdesk']['agent_queue_prefix'][profilename] !== 'undefined') {
                                    var queueprefix = pluginconfig['hotdesk']['agent_queue_prefix'][profilename];
                                    if(queueprefix.length>0) {
                                        var qstr = chan+"|Penalty=0|MemberName="+name+"|Queue="+queueprefix+hotdeskpositionvirtual+"|Profile="+profilename;
                                        // console.warn('hotdesk qstr = '+qstr);
                                        qar.push(qstr); 
                                    } 
                                }
                            }
                            if(typeof pluginconfig['hotdesk']['popup_url'] !== 'undefined') {
                                if(typeof pluginconfig['hotdesk']['popup_url'][profilename] !== 'undefined') {
                                    popupUrlRinging = pluginconfig['hotdesk']['popup_url'][profilename];
                                    popupUrlConnect = pluginconfig['hotdesk']['popup_url'][profilename];
                                    getPopupUrlRinging = pluginconfig['hotdesk']['popup_url'][profilename];
                                    getPopupUrlConnect = pluginconfig['hotdesk']['popup_url'][profilename];
                                    window.name = addUrlParameter(window.name,'popupurlringing',getPopupUrlRinging);
                                    window.name = addUrlParameter(window.name,'popupurlconnect',getPopupUrlConnect);
                                    if(getPopupUrlRinging!='') { autoPopup=true; }
                                }
                            }

                            finalstring = qar.join("&");
                            sendqchan = Base64.encode(finalstring);
                            send("<msg data=\"GENERAL|qchan|" + sendqchan + "~"+ hotdesk_autoclose+"|\" />");
                            send("<msg data=\"GENERAL|mychan|" + hotdeskposition + "|\" />");
                            setTimeout(function() { send("<msg data=\"GENERAL|hotdeskmap|" + hotdeskpositionvirtual + '~' + hotdeskpositionextension +  '~' + hotdeskposition + "|\" />"); }, 3000);
                            botonitos[myposition].QUEUECHANNEL=finalstring; // set this so queue pause from presence can check for queue membership
                        }
                        $('#hotdesklogin').modal('hide');
                    });

                    $('#hotdesklogin').modal({backdrop: 'static', keyboard: false});
                } // end data start

                for (var pepe in data['p']) {
                    $('#hotdeskposition').append($('<option>').text(data['p'][pepe]['e']).attr('value', data['p'][pepe]['d']));
                }

                if(typeof data['end'] == 'undefined') {
                } else {
                    //console.warn('new hotdeskposition end')
                    var getHotdeskPosition  = gup("hotdeskposition");
                    //$('#hotdeskposition option:selected').removeAttr('selected');
                    $('#hotdeskposition option:selected').removeProp('selected');
                    $('#hotdeskposition > option').each(function() { console.log("nico each gethotdeskposition "+getHotdeskPosition); if(getHotdeskPosition==this.text) {  $(this).attr('selected','selected'); $(this).prop('selected',true); if(getHotdeskPosition=="") { } else { hotdesk_autoclose++; } }  });


                    // render profile only on end
                    var sortedkeys = [];
                    hotdesk_allowed_profiles.forEach(function(key,index,array) {
                        sortedkeys.push(key);
                    });

                    sortedkeys.sort();

                    for (var i=0,  tot=sortedkeys.length; i < tot; i++) {
                        var key = sortedkeys[i];
                        if(pluginconfig['hotdesk']['profile'].hasOwnProperty(key)) {
                          if(key=='') {
                          // discard empty option
                          } else {
                              $('#hotdeskprofile').append($('<option>').text(key).attr('value', pluginconfig['hotdesk']['profile'][key]));
                          }
                       }
                    }

                    var getHotdeskProfile  = gup("hotdeskprofile");
                    //$('#hotdeskprofile option:selected').removeAttr('selected');
                    $('#hotdeskprofile option:selected').removeProp('selected');
                    $('#hotdeskprofile > option').each(function() { if(getHotdeskProfile==encodeURI(this.text)) {  $(this).prop('selected',true);  if(getHotdeskProfile=="") { } else { hotdesk_autoclose++; } } });

                    //console.warn("hotdesk autoclose "+hotdesk_autoclose);

                    if(hotdesk_autoclose==2) { 
                        $('#hotdesklogin').modal('hide');
                    }

                }

                $('#hotdeskposition').selectpicker('refresh');
                $('#hotdeskprofile').selectpicker('refresh');

            }
        }
    }
}());
