%hotdesk_okpeer = ();
@hotdesk_allqueues = ();

my $hotdesk_cleanup_script = defined($main::pluginconfig{'hotdesk'}{'cleanup_script'}{''})?$main::pluginconfig{'hotdesk'}{'cleanup_script'}{''}:'/usr/bin/php -f /var/www/html/fop2/admin/plugins/hotdesk/cleanup.php';

$timer_hotdesk_clean_sessions = AnyEvent->timer(
    after    => 60,
    interval => 180,
    cb       => sub {
        hotdesk_cleanup();
    }
);

sub hotdesk_cleanup {
    my @allreturn = ();
    my $final_script = "$hotdesk_cleanup_script";
    print "nico cleanup $final_script\n";
    $output = `$final_script`;
    print "nico cleanup $output\n";
    # hotdesk_logoff($channel,$qchanstring,$destino,$contexto);
    #
    # Split output into lines and process each one
    foreach my $line (split(/\n/, $output)) {
        next unless $line =~ /\S/;
        my ($channel, $qchannel, $position, $context) = split(/,/, $line);
        $_ =~ s/^\s+|\s+$//g for ($channel, $qchannel, $position, $context);
        
        # Call hotdesk_logoff if we got all required parameters
        if (defined $channel && defined $qchannel && defined $position && defined $context) {
            my @commands = hotdesk_logoff($channel, $qchannel, $position, $context);
            
            foreach my $cmd (@commands) {
                my %params;
                foreach my $line (split(/\r\n/, $cmd)) {
                    if ($line =~ /^([^:]+):\s*(.*)$/) {
                        $params{$1} = $2;
                    }
                }
                
                foreach my $manager_host (keys %main::managers) {
                    if ($main::astman{$manager_host}->{LOGGEDIN}) {
                        hotdesk_send_command_to_manager(
                            $main::astman{$manager_host},
                            \%params,
                            "ignore!0!0"
                        );
                    }
                }
            }
        }
        else {
            print "WARNING: HOTDESK clean Malformed line - $line\n";
        }
    }
}

$Client_Post_Command_Handler{'hotdesk'}{'qchan'} = sub {
    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;

    my @partes = split(/~/,$destino);
    my $qchanstring = FOP2::utils::decode_base64($partes[0]);
    my $autoclose = $partes[1];

    @hotdesk_allqueues = ();
    my $btn_cfg = main::get_btn_config();
    foreach my $ctx ( keys( %{$btn_cfg} ) ) {
        my @pepi = @{ $btn_cfg->{$ctx} };
        foreach my $cadauno (@pepi) {
            # mapa de colas
            if ( defined( $cadauno->{TYPE} ) ) {
                if ($cadauno->{TYPE} =~ m/queue/i) {
                   if($cadauno->{MAINCHANNEL} =~ m/^QUEUE\/(.*)\^(.*)/isx) {
                       push @hotdesk_allqueues, $1;
                   }
                }
            }
        }
    }

    print "nico hotdesk qchan origen $origen destino $destino contexto $contexto socket $socket queuechannel string $qchanstring autoclose $autoclose\n";

    my $return  = "";
    
    @partes = split(/\&/,$qchanstring);

    my $count = 1;
    foreach my $elem (@partes) {

        my $profile = "";
        my $queue   = "";
        my $name    = "";
        my $penalty = "";
        my $chan    = "";

        # print "elem $elem\n";

        @pertes = split (/\|/,$elem);
        $chan = $pertes[0];

        foreach my $itm (@pertes) {

            # print "item $itm\n";

            if($itm =~ m/^Profile=(.*)/) {
                $profile = $1;
            }
            if($itm =~ m/^Queue=(.*)/) {
                $queue = $1;
            }
            if($itm =~ m/^MemberName=(.*)/) {
                $name = $1;
            }
            if($itm =~ m/^Penalty=(.*)/) {
                $penalty = $1;
            }
        }

        if($queue eq "") { 
            # Si el perfil no tiene cola, no enviamos queueadd, solo queuelog con cola = nombre de perfil
            $queue = $profile; 
            $return  = "Action: QueueLog\r\n"; 
            $return .= "Queue: $queue\r\n";
            $return .= "Event: ADDMEMBER\r\n";
            $return .= "Interface: $name\r\n\r\n";
            push @allreturn, $return;
        } else {
            if($count==1) {
                foreach my $qname (@hotdesk_allqueues) {
                    $return  = "Action: QueueRemove\r\n";
                    $return .= "Queue: $qname\r\n";
                    $return .= "Interface: $chan\r\n";
                    push @allreturn, $return;
                }
                $count++;
            }
            $return  = "Action: QueueAdd\r\n";
            $return .= "Queue: $queue\r\n";
            $return .= "Interface: $chan\r\n";
            $return .= "Penalty: $penalty\r\n";
            $return .= "MemberName: $name\r\n\r\n";
            push @allreturn, $return;
        }

    }
    if($autoclose eq "2") {
        # do not add or remove from queue in auto close
        @allreturn = ();
    }
    #print Dumper @allreturn;

    return @allreturn;
};

$Client_Pre_Command_Handler{'hotdesk'}{'xqlogadd'} = sub {
    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;
    my ($cola,$name) = split (/~/,$destino);

    # print "origen $origen destino $destino contexto $contexto socket $socket\n";

    my $qchanstring = main::get_btn_config($contexto,$origen,'QUEUECHANNELGET');
    my $profile = "";
    my $chan    = "";

    @partes = split(/\&/,$qchanstring);
    foreach my $elem (@partes) {
        # print "elem $elem\n";
        @pertes = split (/\|/,$elem);
        $chan = $pertes[0];
        foreach my $itm (@pertes) {
            if($itm =~ m/^Profile=(.*)/) {
                $profile = $1;
            }
        }
    }

    $return = "Action: QueueLog\r\n"; 
    $return   .= "Queue: $cola\r\n";
    $return   .= "Event: ADDMEMBER\r\n";
    $return   .= "Interface: $name\r\n\r\n";
    push @allreturn, $return;

    #print Dumper @allreturn;

    return @allreturn;

};

$Client_Pre_Command_Handler{'hotdesk'}{'hotdeskmap'} = sub {
    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;

    my ($virtual,$real,$channel64) = split(/~/,$destino);
    my $channel = FOP2::utils::decode_base64($channel64);
 
    $return  = "Action: DBPut\r\n";
    $return .= "Family: AMPUSER\r\n";
    $return .= "Key: $virtual/device\r\n";
    $return .= "Val: $real\r\n";
    $return .= "\r\n";
    push @allreturn, $return;

    $return  = "Action: DBPut\r\n";
    $return .= "Family: hotdeskmap\r\n";
    $return .= "Key: $channel\r\n";
    $return .= "Val: $virtual\r\n";
    $return .= "\r\n";
    push @allreturn, $return;


    return @allreturn;

};

$Client_Pre_Command_Handler{'hotdesk'}{'hotdeskprofile'} = sub {
    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;

    my ($profilename,$channel64) = split(/~/,$destino);
    my $channel = FOP2::utils::decode_base64($channel64);

    my $dialprefix = defined($main::pluginconfig{'hotdesk'}{'prefix'}{$profilename})?$main::pluginconfig{'hotdesk'}{'prefix'}{$profilename}:'';

    # print "hotdeskprofile origen $origen, destino $destino, contexto $contexto , socket $socket, profile name $profilename, channel $channel, prefix $dialprefix\n";

    $return  = "Action: DBPut\r\n";
    $return .= "Family: profile\r\n";
    $return .= "Key: $channel\r\n";
    $return .= "Val: $profilename\r\n";
    $return .= "\r\n";
    push @allreturn, $return;

    $return  = "Action: DBPut\r\n";
    $return .= "Family: dialprefix\r\n";
    $return .= "Key: $profilename\r\n";
    $return .= "Val: $dialprefix\r\n";
    $return .= "\r\n";
    push @allreturn, $return;

    return @allreturn;
};

$Client_Pre_Command_Handler{'hotdesk'}{'hotdeskdoverify'} = sub {
    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;
    my ($pin,$channel64,$extensionvirtual) = split(/~/,$destino);
    my $channel = FOP2::utils::decode_base64($channel64);

    $return  = "Action: Originate\r\n"; 
    $return .= "Channel: $channel\r\n";
    $return .= "Application: Authenticate\r\n";
    $return .= "Async: 1\r\n";
    $return .= "Data: $pin,a\r\n\r\n";
    push @allreturn, $return;

    # print "seteo la variable hotdesk verify para $channel en valor $pin\n"; 

    $main::pluginvariable{'hotdesk'}{'verify'}{$channel}=$pin . "~" . $extensionvirtual;

    return @allreturn;
};

$Client_Pre_Command_Handler{'hotdesk'}{'hotdeskgetmap'} = sub {
    my @allreturn = ();
    my $origen    = shift;
    my $destino   = shift;
    my $contexto  = shift;
    my $socket    = shift;
    foreach my $manager_host ( keys %main::managers ) {
        if ( $main::astman{$manager_host}->{LOGGEDIN} ) {
            hotdesk_send_command_to_manager( $main::astman{$manager_host}, {
                  Action => 'Command',
                  Command => 'database show hotdeskmap'
                }, "hotdeskHOTDESKMAP!$origen!$destino" );
            hotdesk_send_command_to_manager( $main::astman{$manager_host}, {
                  Action => 'Command',
                  Command => 'database show qchanget'
                }, "hotdeskQCHANGET!$origen!$destino" );
        }
    }
    return @allreturn;
};

$Client_Pre_Command_Handler{'hotdesk'}{'getallowedprofiles'} = sub {
    my @allreturn = ();
    my $origen    = shift;
    my $destino   = shift;
    my $contexto  = shift;
    my $socket    = shift;
    my $channel   = main::get_btn_config($contexto, $origen, 'MAINCHANNEL');
    my $extension = main::get_btn_config($contexto, $origen, 'EXTENSION');

    foreach my $k (keys %main::clients) {
        my $sock = $main::clients{$k};
        my $user = defined( $main::flash_username{$sock} ) ? $main::flash_username{$sock} : 'no user';

        if($user eq $extension) {

            my $mainchannel = main::get_btn_config($contexto,$origen,'MAINCHANNEL');
            my $qchanstring = main::get_btn_config($contexto,$origen,'QUEUECHANNELGET');

            if($qchanstring ne "") {
                if($sock ne $socket) { # Do not close myself
                    @allreturn = hotdesk_logoff($channel,$qchanstring,$destino,$contexto);
                    $main::pluginvariable{'hotdesk'}{'closeonduplicate'}{$sock}=1;
                    my $valor = "$origen\@$contexto|disconnectDuplicate|0|0";
                    hotdesk_send_status_to_flash( $sock, $valor  );
                }
            }

        }
    }

    $return  = "Action: DBGet\r\n";
    $return .= "Family: HOTDESK/$destino\r\n";
    $return .= "Key: allowed\r\n";
    $return .= "ActionId: getvar!HOTDESK/$destino/allowed!$channel!$contexto\r\n";
    $return .= "\r\n";

    push @allreturn, $return;

    return @allreturn;
};

$Client_Pre_Command_Handler{'hotdesk'}{'hotdeskpositions'} = sub {
    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;
    my @elemento;
    my $ufilter;

    my $peerfilter = defined($main::pluginconfig{'hotdesk'}{'filter'}{''})?$main::pluginconfig{'hotdesk'}{'filter'}{''}:'';
    if($peerfilter ne "") { $ufilter = $peerfilter; $peerfilter = "like $peerfilter"; }
    my $mychannel = main::get_btn_config( "$contexto", $origen, 'MAINCHANNEL');

    # print "origen $origen, destino $destino, contexto $contexto , socket $socket, channel $mychannel, filter ($peerfilter)\n";

    foreach my $final (sort keys %hotdesk_okpeer) {
      my $channel;
        if ($final =~ /^PJ(\d+)$/) {  # Matches "PJ" followed by digits
            $final = $1;             # $1 captures the digits part
            $channel = "PJSIP";
        } else {
            $channel = "SIP";
        }
        if($final =~ m/^$ufilter/) {
            push @elemento, "{\"e\":\"$final\",\"d\":\"$channel/$final\"}";
        } 
    }
 
    $returnjson = " {\"p\":[";
    $returnjson .= join(",",@elemento);
    $returnjson .= "]}";

    my @manual;

    # 15 extensions is a safe bet to avoid having data larger than 1024 bytes
    $size=15;

    for( 0..$#elemento ) {
        my $row = int ($_ / $size);
        $manual[$row]=[] unless exists $manual[$row];
        push @{$manual[$row]}, $elemento[$_];
    }

    for ( 0..$#manual ) {
        $returnjson = "";

        # we append start or end json variables, or both if all of them fit on one event
        $startend="";
        if($#manual == $_) {
            $startend.= ",\"end\":\"1\"";
        }
        if ($_ == 0) {
            $startend.= ",\"start\":\"1\"";
        } 
   
        $returnjson = "{\"p\":[";
        $returnjson .= join(",",@{$manual[$_]});
        $returnjson .= "]$startend}";

        # print $returnjson."\n";

        my $returnjson64 = FOP2::utils::encode_base64($returnjson);

        $return  = "Action: UserEvent\r\n";
        $return .= "UserEvent: ListPositions\r\n";
        $return .= "Channel: $mychannel\r\n";
        $return .= "Family: hotdeskpositions\r\n";
        $return .= "Value: $returnjson64\r\n";
        $return .= "\r\n";
        push @allreturn, $return;

    }

    return @allreturn;
};

$Client_Pre_Command_Handler{'hotdesk'}{'logoff'} = sub {
    my $origen     = shift;
    my $destino    = shift;
    my $contexto   = shift;
    my $socket     = shift;
    my $extension  = shift;
    my @allreturn;
    my $return = '';

    print "logoff origen $origen destino $destino contexto $contexto socket $socket extension $extension\n";

    if(defined($main::pluginvariable{'hotdesk'}{'closeonduplicate'}{$socket})) {
        delete $main::pluginvariable{'hotdesk'}{'closeonduplicate'}{$socket};
        print "skip logoff in hotdesk because closeon duplicate\n";
        return;
    }

    my $user = $main::flash_username{$socket};
    my $mainchannel = main::get_btn_config($contexto,$origen,'MAINCHANNEL');
    my $qchanstring = main::get_btn_config($contexto,$origen,'QUEUECHANNELGET');

    print "main channel en logoff $mainchannel\n";
    print "qchan string = ($qchanstring)\n";

    if($qchanstring ne "") {
        @allreturn = hotdesk_logoff($mainchannel,$qchanstring,$origen,$contexto);
    } else {
         # print "no tenia qchanstring\n";
    }
    delete $main::pluginvariable{'hotdesk'}{'mychan'}{$user};
    return @allreturn;
};

$Client_Pre_Command_Handler{'hotdesk'}{'mychan'} = sub {

    # Interceptamos el mychan para guardar el canal al cual poner pausa y demas con el presence box

    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;
    my $return   = '';
    my ($key,$exten,$data) = split(/~/,$destino);

    # print "hotdesk intercept mychan on server $origen, $destino, $contexto, $socket\n";

    my $user = $main::flash_username{$socket};

    my $channel = FOP2::utils::decode_base64($destino);
    $main::pluginvariable{'hotdesk'}{'mychan'}{$user} = $channel;

    return @allreturn;
};

$Client_Pre_Command_Handler{'hotdesk'}{'setastdb'} = sub {
   
    # Interceptamos cambios de presencia para poner en pausa y setear astdb pausecustom para asternic

    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;
    my $return   = '';
    my ($key,$exten,$data) = split(/~/,$destino);

    my $channel = $main::pluginvariable{'hotdesk'}{'mychan'}{$exten};

    # print "setastdb origen $origen, destino $destino ($key,$exten,$data), contexto $contexto, socket $socket, channel de pluginvariable $channel\n";

    if( $data =~ m/^([A-Za-z0-9+\/]{4})*([A-Za-z0-9+\/]{4}|[A-Za-z0-9+\/]{3}=|[A-Za-z0-9+\/]{2}==)$/) {
        $data = FOP2::utils::decode_base64($data);
    }

    if($key eq "fop2state") {
        if($data ne "") {
            my $epoch = time();
            $return  = "Action: DBPut\r\n";
            $return .= "Family: PAUSECUSTOM\r\n";
            $return .= "Key: $channel\r\n";
            $return .= "Val: $data:$epoch\r\n";
            $return .= "\r\n";
            push @allreturn, $return;

            $return  = "Action: QueuePause\r\n";
            $return .= "Interface: $channel\r\n";
            $return .= "Paused: 1\r\n";
            $return .= "Reason: $data\r\n";
            $return .= "\r\n";
            push @allreturn, $return;

        } else {
            $return  = "Action: DBDel\r\n";
            $return .= "Family: PAUSECUSTOM\r\n";
            $return .= "Key: $channel\r\n";
            $return .= "\r\n";
            push @allreturn, $return;

            $return  = "Action: QueuePause\r\n";
            $return .= "Interface: $channel\r\n";
            $return .= "Paused: 0\r\n";
            $return .= "\r\n";
            push @allreturn, $return;
 
       }
    }
    return @allreturn;
};

$AMI_Event_Handler{'hotdesk'}{'PEERENTRY'} = sub {
    # Para tener la lista de sip peers registrados, y evitar usar asterisk rx
    my $event = shift;
    my @allreturn;
    my $status = ${$event}{'Status'};
    my $obj    = ${$event}{'ObjectName'};
    if($status =~ /OK/) {
        $hotdesk_okpeer{$obj}="ok";
        print "entry peer $obj ok\n";
    }
    #print Dumper \%hotdesk_okpeer;
};

$AMI_Event_Handler{'hotdesk'}{'PEERSTATUS'} = sub {
    # Para tener la lista de sip peers registrados, y evitar usar asterisk rx

    my $event = shift;
    my @allreturn;

    my $obj = ${$event}{Peer};
    my $status = ${$event}{PeerStatus}; 
    $obj =~ s|SIP/||g; # this will leave PJ if pjsip, we will use that to set the actual channel later
    if($status eq "Registered" || $status eq "Reachable" || $status eq "Not in use") {
        print "status peer $obj ok\n";
        $hotdesk_okpeer{$obj}="ok";
    } else {
        delete $hotdesk_okpeer{$obj};
        print "status borro peer $obj (status $status)\n";
    }
    #print Dumper \%hotdesk_okpeer;
};

$AMI_Event_Handler{'hotdesk'}{'ORIGINATERESPONSE'} = sub {

    # Guardamos el numero discado de un originate response que tenga canal Local
    # Y vamos a usarlo cuando recibamos un link entre local y sip/real

    my $event = shift;
    my @allreturn;

    $response   = ${$event}{Response};
    $channel    = FOP2::utils::get_channel(${$event}{Channel});

    if($response eq "Success") {
        if($channel =~ /^LOCAL/) {
            $main::pluginvariable{'hotdesk'}{'dialednumber'}{$channel} = ${$event}{Exten};
        }
    }

    return @allreturn;
};

$AMI_Event_Handler{'hotdesk'}{'LINK'} = sub {
    my $event = shift;
    my @allreturn;

    # Interceptamos un LINK para sacar el dialed number guardado en el originate response
    # Y de paso ponemos direccion saliente al canal virtual/custom

    $canal  = FOP2::utils::get_channel(${$event}{Channel1});
    $canal2 = FOP2::utils::get_channel(${$event}{Channel2});

    if ( $canal =~ /^LOCAL/ && $canal2 !~ /^LOCAL/ ) {
        if($canal2 =~ /^VIRTUAL/ || $canal2 =~ /^CUSTOM/) {

            $dialednum = $main::pluginvariable{'hotdesk'}{'dialednumber'}{$canal};

            if($dialednum ne "") {
                $return  = "Action: UserEvent\r\n";
                $return .= "UserEvent: direction\r\n";
                $return .= "Channel: $canal2\r\n";
                $return .= "Family: directionhotdesk\r\n";
                $return .= "Value: outbound\r\n";
                $return .= "\r\n";
                push @allreturn, $return;

                $return  = "Action: UserEvent\r\n";
                $return .= "UserEvent: settext\r\n";
                $return .= "Channel: $canal2\r\n";
                $return .= "Family: settexthotdesk\r\n";
                $return .= "Value: $dialednum\r\n";
                $return .= "\r\n";
                push @allreturn, $return;
 
            }
 
        }
    } else {

    }

    return @allreturn;
};

$AMI_Event_Handler{'hotdesk'}{'NEWACCOUNTCODE'} = sub {
    my $event = shift;
    my @allreturn;

    my @partes = split( /-/, ${$event}{Channel} );
    pop(@partes);
    my $canal = uc( join( "-", @partes ) );

    # print "canal $canal\n";
    # print "event channel ".${$event}{Channel}."\n";

    my $accode = ${$event}{AccountCode};

    if ( defined ( $main::pluginvariable{'hotdesk'}{'verify'}{$canal} ) ) {
        my ($pin,$extensionvirtual) = split(/~/,$main::pluginvariable{'hotdesk'}{'verify'}{$canal});
        if ( $pin eq $accode ) {
            # print "El canal $canal puso bien el pin $accode para canal $newcanal\n";

            my $newcanal = "CUSTOM/".$extensionvirtual;
            $return  = "Action: UserEvent\r\n";
            $return .= "UserEvent: verified\r\n";
            $return .= "Channel: $newcanal\r\n";
            $return .= "Family: verified\r\n";
            $return .= "Value: $pin\r\n";
            $return .= "\r\n";
            push @allreturn, $return;
 
            $newcanal = "VIRTUAL/".$extensionvirtual;
            $return  = "Action: UserEvent\r\n";
            $return .= "UserEvent: verified\r\n";
            $return .= "Channel: $newcanal\r\n";
            $return .= "Family: verified\r\n";
            $return .= "Value: $pin\r\n";
            $return .= "\r\n";
            push @allreturn, $return;

            delete $main::pluginvariable{'hotdesk'}{'verify'}{$canal};
 
        } else {
            # print "El canal $canal NO NO puso bien el pin $accode\n";
        }
    } else {
        # print "no esta definida la variable de hotdesk verify para $canal\n";
    }

    return @allreturn;
};

sub hotdesk_logoff {

    my @allreturn = ();
    my $mainchannel = shift;
    my $qchanstring = shift;
    my $destino = shift;
    my $contexto = shift;

    print "hotdesk logoff mainchannel $mainchannel tenia qchan $qchanstring, destino $destino, contexto $contexto\n";
    # qchan SIP/603|Penalty=0|MemberName=Nicolas Softphone|Queue=103
    #
    my ($extracted_number) = $mainchannel =~ m|/(\d+)|;
    my $return  = "Action: DBDel\r\n";
    $return .= "Family: PAUSECUSTOM\r\n";
    $return .= "Key: AGENT/$extracted_number\r\n";
    $return .= "\r\n";
    push @allreturn, $return;

    @partes = split(/\&/,$qchanstring);

    foreach my $elem (@partes) {
        # print "elem $elem\n";
        @pertes = split (/\|/,$elem);
        my $chan = $pertes[0];
        my $queue = "";
        my $name = "";
        foreach my $itm (@pertes) {
            if($itm =~ m/^MemberName=(.*)/) {
                $name = $1;
            }
        }

        $return  = "Action: QueuePause\r\n";
        $return .= "Interface: $chan\r\n";
        $return .= "Paused: 0\r\n";
        $return .= "\r\n";
        push @allreturn, $return;

        $return  = "Action: DBDel\r\n";
        $return .= "Family: PAUSECUSTOM\r\n";
        $return .= "Key: $chan\r\n";
        $return .= "\r\n";
        push @allreturn, $return;

        $return  = "Action: DBDel\r\n";
        $return .= "Family: profile\r\n";
        $return .= "Key: $chan\r\n";
        $return .= "\r\n";
        push @allreturn, $return;

        $return  = "Action: DBDel\r\n";
        $return .= "Family: fop2state\r\n";
        $return .= "Key: $mainchannel\r\n";
        $return .= "\r\n";
        push @allreturn, $return;

        $return  = "Action: DBDel\r\n";
        $return .= "Family: hotdeskmap\r\n";
        $return .= "Key: $chan\r\n";
        $return .= "\r\n";
        push @allreturn, $return;

        $return  = "Action: DBDel\r\n";
        $return .= "Family: qchanget\r\n";
        $return .= "Key: ${destino}_${contexto}\r\n";
        $return .= "\r\n";
        push @allreturn, $return;



        $return  = "Action: DBPut\r\n";
        $return .= "Family: AMPUSER\r\n";
        $return .= "Key: $destino/device\r\n";
        $return .= "Val: \r\n";
        $return .= "\r\n";
        push @allreturn, $return;

        $return  = "Action: UserEvent\r\n";
        $return .= "UserEvent: FOP2ASTDB\r\n";
        $return .= "Channel: $mainchannel\r\n";
        $return .= "Family: fop2state\r\n";
        $return .= "Value: \r\n";
        $return .= "\r\n";
        push @allreturn, $return;

        my @removequeue;
        my @removequeuelog;
        my $profilename;

        foreach my $itm (@pertes) {
            if($itm =~ m/^Profile=(.*)/) {
                $profilename = $1;
            }
        }

        foreach my $itm (@pertes) {
            if($itm =~ m/^Queue=(.*)/) {
                $queue = $1;
                if($queue ne "") {
                    push @removequeue, $queue;
                    push @removequeuelog, $queue;
                } else {
                    push @removequeuelog, $profilename;
                }
            }
        }

        foreach my $itm (@removequeue) {
            $return = "Action: QueueRemove\r\n";
            $return .= "Queue: $itm\r\n";
            $return .= "Interface: $chan\r\n\r\n";
            push @allreturn, $return;
            # print "$return\n\n";
        }

        foreach my $itm (@removequeuelog) {
            $return = "Action: QueueLog\r\n"; 
            $return.= "Queue: $itm\r\n";
            $return.= "Event: REMOVEMEMBER\r\n";
            $return.= "Interface: $name\r\n\r\n";
            push @allreturn, $return;
            # print "$return\n\n";
        }

    }
    return @allreturn;
}

#For Queue Remove
$AMI_Event_Handler{'hotdesk'}{'QUEUEMEMBERREMOVED'} = sub {
    my $event = shift;
    my @allreturn = ();
    my $return = '';

    my $exten = '';
    if(defined(${$event}{'Location'})) {
        $exten = ${$event}{'Location'};
    } else {
        # asterisk 13
        $exten = ${$event}{'Interface'};
    }

    my $queue = ${$event}{'Queue'};

    $return  = "Action: DBDel\r\n";
    $return .= "Family: hotdeskmap\r\n";
    $return .= "Key: $exten\r\n";
    $return .= "\r\n";
    push @allreturn, $return;

    $return  = "Action: UserEvent\r\n";
    $return .= "Family: HOTDESKQUEUEREMOVE\r\n";
    $return .= "Channel: $exten\r\n";
    $return .= "Key: HOTDESKQUEUEREMOVE\r\n";
    $return .= "Value: $exten\r\n";
    $return .= "\r\n";
    push @allreturn, $return;
 
    return @allreturn;
};

sub hotdesk_handle_ami_response {
    my ( $asterisk, $response, $extra ) = @_;
    my @allreturn;
    if ( defined($extra) && $extra ne "" ) {
        my ( $command, $origen, $destino ) = split( /\!/, $extra );
        main::log_debug( "** HOTDESK: handler ami response, command $command, extra  $extra, origen $origen, destino $destino", 128) if $main::dodebug;
        if($command ne "hotdeskHOTDESKMAP" && $command ne "hotdeskQCHANGET") { print "discard HOTDESK ami response $command\n"; return; }

        foreach my $linea (@{$response->{CMD}}) {
            if ($linea =~ m/hotdeskmap/) {
                my ($nothing,$mapexten) = split(/:/,$linea);
                my $channel_part = substr($nothing, 12);
                $channel_part =~ s/\s+$//;
                $mapexten =~ s/\s+//g;
                if($destino eq $mapexten) {
                    my $mainchannel = "CUSTOM/".$destino;
                    foreach my $manager_host ( keys %main::managers ) {
                        if ( $main::astman{$manager_host}->{LOGGEDIN} ) {
                            hotdesk_send_command_to_manager( $main::astman{$manager_host}, {
                                  Action => 'UserEvent',
                                  UserEvent => 'HOTDESKALREADYLOGGED',
                                  Channel => $mainchannel,
                                  Family => 'HOTDESKALREADYLOGGED',
                                  Key => $mainchannel,
                                  Value => $channel_part
                                }, "hotdeskALREADYLOGGED!$origen!$destino" );
                        }
                    }

                    print "nothing $nothing, mapexten $mapexten hotdesk already logged\n";
                }
            } elsif ($linea =~ m/qchanget/) {
                my ($nothing,$qchanstring) = split(/:/,$linea);
                my $channel_part = substr($nothing, 10);
                $channel_part =~ s/\s+$//;
                $qchanstring =~ s/\s+$//;
                $qchanstring = FOP2::utils::encode_base64($qchanstring);
                my ($btnpos,$btncontext) = split(/_/,$channel_part,2);
                if($btncontext eq "GENERAL") { $btncontext=''; }
                print "HOTDESK QCHANGET hago algo al cliente $linea, btncontext ($btncontext) context ($context) origen ($origen) btnpos ($btnpos)\n";
                if(lc($context) eq lc($btncontext)) {
                   if($origen eq $btnpos || $origen eq "0") {
                        my $mainchannel = "CUSTOM/".$destino;
                        print "HOTDESK QCHANGET hago algo con $qchanstring mainchannel $mainchannel\n";
                        foreach my $manager_host ( keys %main::managers ) {
                            if ( $main::astman{$manager_host}->{LOGGEDIN} ) {
                                hotdesk_send_command_to_manager( $main::astman{$manager_host}, {
                                      Action => 'UserEvent',
                                      UserEvent => 'HOTDESKQCHANGET',
                                      Channel => $mainchannel,
                                      Family => 'HOTDESKQCHANGET',
                                      Key => $mainchannel,
                                      Value => $qchanstring
                                    }, "hotdeskHOTDESKQCHANGET!$origen!$destino" );
                            }
                        }
 
                   }
                } else {
                   print "HOTDESK QCHANGET no hago nada con  $qchanstring\n";
                }
            } else {
               print "HOTDESK no se que hago con linea $linea\n";
            }
        }
    }
    return @allreturn;
};

sub hotdesk_send_command_to_manager {

    my ( $asterisk, $comando, $extra ) = @_;
    if ( !defined($extra) ) { $extra = ''; }
    if ( !defined($asterisk) ) { return; }

    my $action_id = $asterisk->send_action(
        $comando,
        sub {
            my ( $asterisk, $response ) = @_;
            \&hotdesk_handle_ami_response( $asterisk, $response, $extra );
        },
        3
    );

    return $action_id;
};
